/* Fo
 * fo-multi_case.h: Multi Case formatting object
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-multi-case.h,v 1.2 2003/03/19 21:11:48 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#ifndef __FO_MULTI_CASE_H__
#define __FO_MULTI_CASE_H__

#include <libfo/fo-utils.h>

#include <fo-property-id.h>
#include <fo-property-role.h>
#include <fo-property-source-document.h>

G_BEGIN_DECLS

typedef struct _FoMultiCase      FoMultiCase;
typedef struct _FoMultiCaseClass FoMultiCaseClass;

#define FO_TYPE_MULTI_CASE              (fo_multi_case_get_type ())
#define FO_MULTI_CASE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_MULTI_CASE, FoMultiCase))
#define FO_MULTI_CASE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_MULTI_CASE, FoMultiCaseClass))
#define FO_IS_MULTI_CASE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_MULTI_CASE))
#define FO_IS_MULTI_CASE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_MULTI_CASE))
#define FO_MULTI_CASE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_MULTI_CASE, FoMultiCaseClass))


GType         fo_multi_case_get_type      (void) G_GNUC_CONST;
FoFo *fo_multi_case_new (void);

void fo_multi_case_update_from_context (FoFo *fo,
				   FoContext *context);
void fo_multi_case_set_id (FoMultiCase *fo_multi_case,
		      FoPropertyId *new_id);
FoPropertyId* fo_multi_case_get_id (FoMultiCase *fo_multi_case);
void fo_multi_case_set_role (FoMultiCase *fo_multi_case,
		      FoPropertyRole *new_role);
FoPropertyRole* fo_multi_case_get_role (FoMultiCase *fo_multi_case);
void fo_multi_case_set_source_document (FoMultiCase *fo_multi_case,
		      FoPropertySourceDocument *new_source_document);
FoPropertySourceDocument* fo_multi_case_get_source_document (FoMultiCase *fo_multi_case);

G_END_DECLS

#endif /* !__FO_MULTI_CASE_H__ */
