/* Fo
 * fo-multi_switch.h: Multi Switch formatting object
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-multi-switch.h,v 1.2 2003/03/19 21:11:50 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#ifndef __FO_MULTI_SWITCH_H__
#define __FO_MULTI_SWITCH_H__

#include <libfo/fo-utils.h>

#include <fo-property-id.h>
#include <fo-property-role.h>
#include <fo-property-source-document.h>

G_BEGIN_DECLS

typedef struct _FoMultiSwitch      FoMultiSwitch;
typedef struct _FoMultiSwitchClass FoMultiSwitchClass;

#define FO_TYPE_MULTI_SWITCH              (fo_multi_switch_get_type ())
#define FO_MULTI_SWITCH(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_MULTI_SWITCH, FoMultiSwitch))
#define FO_MULTI_SWITCH_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_MULTI_SWITCH, FoMultiSwitchClass))
#define FO_IS_MULTI_SWITCH(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_MULTI_SWITCH))
#define FO_IS_MULTI_SWITCH_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_MULTI_SWITCH))
#define FO_MULTI_SWITCH_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_MULTI_SWITCH, FoMultiSwitchClass))


GType         fo_multi_switch_get_type      (void) G_GNUC_CONST;
FoFo *fo_multi_switch_new (void);

void fo_multi_switch_update_from_context (FoFo *fo,
				   FoContext *context);
void fo_multi_switch_set_id (FoMultiSwitch *fo_multi_switch,
		      FoPropertyId *new_id);
FoPropertyId* fo_multi_switch_get_id (FoMultiSwitch *fo_multi_switch);
void fo_multi_switch_set_role (FoMultiSwitch *fo_multi_switch,
		      FoPropertyRole *new_role);
FoPropertyRole* fo_multi_switch_get_role (FoMultiSwitch *fo_multi_switch);
void fo_multi_switch_set_source_document (FoMultiSwitch *fo_multi_switch,
		      FoPropertySourceDocument *new_source_document);
FoPropertySourceDocument* fo_multi_switch_get_source_document (FoMultiSwitch *fo_multi_switch);

G_END_DECLS

#endif /* !__FO_MULTI_SWITCH_H__ */
