/* Fo
 * fo-repeatable_page_master_alternatives.c: Repeatable Page Master Alternatives formatting object
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-repeatable-page-master-alternatives.c,v 1.2 2003/03/19 21:12:07 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#include "libfo/fo-utils.h"
#include "fo/fo-fo.h"
#include "fo/fo-fo-private.h"
#include "fo-repeatable-page-master-alternatives.h"
#include "fo-conditional-page-master-reference.h"


enum {
  PROP_0
};

struct _FoRepeatablePageMasterAlternatives
{
  FoFo parent_instance;

};

struct _FoRepeatablePageMasterAlternativesClass
{
  FoFoClass parent_class;
  
};

static void fo_repeatable_page_master_alternatives_init        (FoRepeatablePageMasterAlternatives      *fo_repeatable_page_master_alternatives);
static void fo_repeatable_page_master_alternatives_class_init  (FoRepeatablePageMasterAlternativesClass *klass);
static void fo_repeatable_page_master_alternatives_set_property (GObject         *object,
                                  guint            prop_id,
                                  const GValue    *value,
                                  GParamSpec      *pspec);
static void fo_repeatable_page_master_alternatives_get_property   (GObject         *object,
                                       guint            prop_id,
                                       GValue          *value,
                                       GParamSpec      *pspec);
static gboolean fo_repeatable_page_master_alternatives_validate_content (FoFo *fo,
									 GError **error);
static void fo_repeatable_page_master_alternatives_finalize    (GObject           *object);
static void fo_repeatable_page_master_alternatives_debug_dump_properties (FoFo *fo, gint depth);

static gpointer parent_class;

GType
fo_repeatable_page_master_alternatives_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoRepeatablePageMasterAlternativesClass),
        (GBaseInitFunc) NULL,
        (GBaseFinalizeFunc) NULL,
        (GClassInitFunc) fo_repeatable_page_master_alternatives_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoRepeatablePageMasterAlternatives),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_repeatable_page_master_alternatives_init,
      };
      
      object_type = g_type_register_static (FO_TYPE_FO,
                                            "FoRepeatablePageMasterAlternatives",
                                            &object_info, 0);
    }
  
  return object_type;
}

static void
fo_repeatable_page_master_alternatives_init (FoRepeatablePageMasterAlternatives *fo_repeatable_page_master_alternatives)
{
}

static void
fo_repeatable_page_master_alternatives_class_init (FoRepeatablePageMasterAlternativesClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  
  parent_class = g_type_class_peek_parent (klass);
  
  object_class->finalize = fo_repeatable_page_master_alternatives_finalize;

  object_class->set_property = fo_repeatable_page_master_alternatives_set_property;
  object_class->get_property = fo_repeatable_page_master_alternatives_get_property;

  FO_FO_CLASS (klass)->debug_dump_properties = fo_repeatable_page_master_alternatives_debug_dump_properties;
  FO_FO_CLASS (klass)->update_from_context = fo_repeatable_page_master_alternatives_update_from_context;
  FO_FO_CLASS (klass)->validate_content = fo_repeatable_page_master_alternatives_validate_content;
  FO_FO_CLASS (klass)->validate = NULL;
  FO_FO_CLASS (klass)->area_new2 = NULL;
}

static void
fo_repeatable_page_master_alternatives_finalize (GObject *object)
{
  FoRepeatablePageMasterAlternatives *fo_repeatable_page_master_alternatives;

  fo_repeatable_page_master_alternatives = FO_REPEATABLE_PAGE_MASTER_ALTERNATIVES (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


static void
fo_repeatable_page_master_alternatives_set_property (GObject         *object,
                         guint            prop_id,
                         const GValue    *value,
                         GParamSpec      *pspec)
{
  FoRepeatablePageMasterAlternatives *fo_repeatable_page_master_alternatives;

  fo_repeatable_page_master_alternatives = FO_REPEATABLE_PAGE_MASTER_ALTERNATIVES (object);

  switch (prop_id)
    {
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void
fo_repeatable_page_master_alternatives_get_property (GObject         *object,
                         guint            prop_id,
                         GValue          *value,
                         GParamSpec      *pspec)
{
  FoRepeatablePageMasterAlternatives *fo_repeatable_page_master_alternatives;

  fo_repeatable_page_master_alternatives = FO_REPEATABLE_PAGE_MASTER_ALTERNATIVES (object);

  switch (prop_id)
    {
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

/**
 * fo_repeatable_page_master_alternatives_new:
 * 
 * Creates a new #FoRepeatablePageMasterAlternatives initialized to default value.
 * 
 * Return value: the new #FoRepeatablePageMasterAlternatives
 **/
FoFo*
fo_repeatable_page_master_alternatives_new (void)
{
  return FO_FO (g_object_new (fo_repeatable_page_master_alternatives_get_type (), NULL));
}

void
fo_repeatable_page_master_alternatives_update_from_context (FoFo *fo, FoContext *context)
{
  g_return_if_fail (fo != NULL);
  g_return_if_fail (FO_IS_REPEATABLE_PAGE_MASTER_ALTERNATIVES (fo));

}

void
fo_repeatable_page_master_alternatives_debug_dump_properties (FoFo *fo, gint depth)
{
  gchar *indent = g_strnfill (depth * 2, ' ');

  g_return_if_fail (fo != NULL);
  g_return_if_fail (FO_IS_REPEATABLE_PAGE_MASTER_ALTERNATIVES (fo));

  g_log (G_LOG_DOMAIN,
	 G_LOG_LEVEL_DEBUG,
	 "%s(No properties)",
	 indent);

  g_free (indent);

  FO_FO_CLASS (parent_class)->debug_dump_properties (fo, depth + 1);
}

gboolean
fo_repeatable_page_master_alternatives_validate_content (FoFo *fo,
							 GError **error)
{
  GError *tmp_error;
  FoNode *fo_node;
  FoNode *child_node;
  gint n_children;

  g_return_val_if_fail (FO_IS_REPEATABLE_PAGE_MASTER_ALTERNATIVES (fo), TRUE);
  g_return_val_if_fail (error == NULL || *error == NULL, TRUE);

  fo_node = FO_NODE (fo);

  fo_fo_trim_whitespace_children (fo);

  n_children = fo_node_n_children (fo_node);

  if (n_children == 0)
    {
      tmp_error = g_error_new (FO_FO_ERROR,
			       FO_FO_ERROR_EMPTY,
			       _(fo_fo_error_messages[FO_FO_ERROR_EMPTY]),
			       fo_object_sprintf (FO_OBJECT (fo)));

      return fo_object_log_or_propagate_error (FO_OBJECT (fo),
					       error,
					       tmp_error);
    }

  child_node = fo_node_first_child (fo_node);

  while (child_node)
    {
      if (FO_IS_CONDITIONAL_PAGE_MASTER_REFERENCE (child_node))
	{
	  child_node = fo_node_next_sibling (child_node);
	}
      else
	{
	  tmp_error = g_error_new (FO_FO_ERROR,
				   FO_FO_ERROR_INVALID_CONTENT,
				   _(fo_fo_error_messages[FO_FO_ERROR_INVALID_CONTENT]),
				   fo_object_sprintf (FO_OBJECT (fo)));

	  return fo_object_log_or_propagate_error (FO_OBJECT (fo),
						   error,
						   tmp_error);
	}
    }

  return FALSE;
}
