/* Fo
 * fo-property-display-align.h: 'display-align' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-display-align.h,v 1.3 2003/07/02 10:39:38 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_DISPLAY_ALIGN_H__
#define __FO_PROPERTY_DISPLAY_ALIGN_H__

#include <libfo/fo-utils.h>
#include <property/fo-property.h>

G_BEGIN_DECLS

/* display-align */
/* auto | before | center | after | inherit */
/* Initial value: auto */
typedef enum {
  FO_ENUM_DISPLAY_ALIGN_AUTO,
  FO_ENUM_DISPLAY_ALIGN_BEFORE,
  FO_ENUM_DISPLAY_ALIGN_CENTER,
  FO_ENUM_DISPLAY_ALIGN_AFTER
} FoEnumDisplayAlign;

GType fo_enum_display_align_get_type (void);
#define FO_TYPE_ENUM_DISPLAY_ALIGN fo_enum_display_align_get_type ()

#define FO_TYPE_PROPERTY_DISPLAY_ALIGN              (fo_property_display_align_get_type ())
#define FO_PROPERTY_DISPLAY_ALIGN(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_DISPLAY_ALIGN, FoPropertyDisplayAlign))
#define FO_PROPERTY_DISPLAY_ALIGN_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_DISPLAY_ALIGN, FoPropertyDisplayAlignClass))
#define FO_IS_PROPERTY_DISPLAY_ALIGN(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_DISPLAY_ALIGN))
#define FO_IS_PROPERTY_DISPLAY_ALIGN_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_DISPLAY_ALIGN))
#define FO_PROPERTY_DISPLAY_ALIGN_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_DISPLAY_ALIGN, FoPropertyDisplayAlignClass))


typedef struct _FoPropertyDisplayAlign      FoPropertyDisplayAlign;
typedef struct _FoPropertyDisplayAlignClass FoPropertyDisplayAlignClass;

GType       fo_property_display_align_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_display_align_new         (void);
FoProperty* fo_property_display_align_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_DISPLAY_ALIGN_H__ */
