/* Fo
 * fo-property-font-weight.h: 'font-weight' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-font-weight.h,v 1.3 2003/03/21 14:41:31 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_FONT_WEIGHT_H__
#define __FO_PROPERTY_FONT_WEIGHT_H__

#include <libfo/fo-utils.h>
#include "fo-property.h"


/* font-weight */
/* normal | bold | bolder | lighter | 100 | 200 | 300 | 400 | 500 | 600 | 700 | 800 | 900 | inherit */
/* Initial value: normal */
typedef enum {
  FO_ENUM_FONT_WEIGHT_NORMAL,
  FO_ENUM_FONT_WEIGHT_BOLD,
  FO_ENUM_FONT_WEIGHT_BOLDER,
  FO_ENUM_FONT_WEIGHT_LIGHTER,
  FO_ENUM_FONT_WEIGHT_100,
  FO_ENUM_FONT_WEIGHT_200,
  FO_ENUM_FONT_WEIGHT_300,
  FO_ENUM_FONT_WEIGHT_400,
  FO_ENUM_FONT_WEIGHT_500,
  FO_ENUM_FONT_WEIGHT_600,
  FO_ENUM_FONT_WEIGHT_700,
  FO_ENUM_FONT_WEIGHT_800,
  FO_ENUM_FONT_WEIGHT_900
} FoEnumFontWeight;

GType fo_enum_font_weight_get_type (void);
#define FO_TYPE_ENUM_FONT_WEIGHT fo_enum_font_weight_get_type ()

typedef struct _FoPropertyFontWeight      FoPropertyFontWeight;
typedef struct _FoPropertyFontWeightClass FoPropertyFontWeightClass;

#include "fo-property.h"

G_BEGIN_DECLS

#define FO_TYPE_PROPERTY_FONT_WEIGHT              (fo_property_font_weight_get_type ())
#define FO_PROPERTY_FONT_WEIGHT(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_FONT_WEIGHT, FoPropertyFontWeight))
#define FO_PROPERTY_FONT_WEIGHT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_FONT_WEIGHT, FoPropertyFontWeightClass))
#define FO_IS_PROPERTY_FONT_WEIGHT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_FONT_WEIGHT))
#define FO_IS_PROPERTY_FONT_WEIGHT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_FONT_WEIGHT))
#define FO_PROPERTY_FONT_WEIGHT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_FONT_WEIGHT, FoPropertyFontWeightClass))


GType       fo_property_font_weight_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_font_weight_new         (void);
FoProperty* fo_property_font_weight_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_FONT_WEIGHT_H__ */
